#! /usr/bin/env python
# -*- coding: utf-8

import time
import datetime
import numpy as np
from itertools import count
import cv2

SENSITIVITY = 150000
INIT_STEPS = 10
UPDATE_INTERVAL = 0.5
FOLDER = "detected"
cam = cv2.VideoCapture(-1)
counter = 0
init_counter = count()
        
if cam.isOpened():
    try:
        while True:
            time.sleep(UPDATE_INTERVAL)
            frame_1 = cam.read()[-1]
            frame_2 = cam.read()[-1]
            changes = 0
            if np.array_equal(frame_1, frame_2):
                raise RuntimeError("cam disconnected")
            for old, new in zip(frame_1, frame_2):
                changes += np.isclose(old, new).sum()
            if counter == INIT_STEPS:
                if changes < SENSITIVITY:
                    print "detected"
                    cv2.imwrite("{0}/{1:%d%b%Y_%H_%M_%S.%f}.png".format(
                        FOLDER, datetime.datetime.utcnow()), frame_2)
            else:
                counter = init_counter.next()
    except KeyboardInterrupt:
        print "capture stopped"
    except RuntimeError as error:
        print error
    else:
        print "capture finished"
    finally:
        cam.release()
else:
    print "no cam"